<?php defined('SYSPATH') || die('No direct script access.');

/**
 * @property $ID int
 * @property $Num int
 * @property $Degree string
 */
class Model_Grades extends Model
{
    /** @return Database_Result */
    public static function loadAll() {
        return DB::query(Database::SELECT, 'CALL `GetGrades`()')->execute();
    }

    public static function getCompoundDisciplinesForGrade($gradeID){
        return DB::query(Database::SELECT, 'CALL `GetCompoundDisciplinesForGrade`(:gradeID)')
            ->param(':gradeID', $gradeID)->execute()->as_array();
    }

    public static function getID($gradeNum, $degree) {
        $sql = 'CALL `Grade_GetID`(:gradeNum, :degree)';
        $res = DB::query(Database::SELECT, $sql)
            ->param(':gradeNum', $gradeNum)
            ->param(':degree', $degree)
            ->execute();

        if (count($res) != 1) {
            return -1;
        }
        return (int)$res[0]['ID'];
    }
}
