<?php defined('SYSPATH') || die('No direct script access.');

class Model_Group extends Model
{
    private $ID;

    public function getID() {
        return $this->ID;
    }

    public static function with($id) {
        $g = new self();
        $g->ID = (int) $id;
        return $g;
    }

    public static function find($gradeID, $groupNum, $facultyID) {
        $sql = 'SELECT `FindGroup`(:gradeID, :groupNum, :facultyID) AS `ID`';
        $id = DB::query(Database::SELECT, $sql)
            ->param(':gradeID', $gradeID)
            ->param(':groupNum', $groupNum)
            ->param(':facultyID', $facultyID)
            ->execute()->get('ID');
        if ($id <= 0) {
            return null;
        }
        return Model_Group::with((int)$id);
    }

    /** @return Model_Discipline[] */
    public function getDisciplines($lazy = true, $semesterID = null) {
        $semesterID = $semesterID ?: User::instance()->SemesterID;
        $sql = 'CALL `GetDisciplinesForGroup`(:id, :semesterID)';
        $query = DB::query(Database::SELECT, $sql)
            ->param(':id', $this->ID)
            ->param(':semesterID', $semesterID)
            ->execute();

        $list = [];
        foreach ($query as $data)
            $list[] = new Model_Discipline($data, true, $lazy);

        return $list;
    }
}
